// SubeditListView.cpp : implementation file
//

#include "stdafx.h"
#include "subedit.h"
#include "SubeditListView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSubeditListView

IMPLEMENT_DYNCREATE(CSubeditListView, CListView)

CSubeditListView::CSubeditListView()
{
	m_subitem = 0;
}

CSubeditListView::~CSubeditListView()
{
}


BEGIN_MESSAGE_MAP(CSubeditListView, CListView)
	//{{AFX_MSG_MAP(CSubeditListView)
	ON_WM_LBUTTONDOWN()
	ON_NOTIFY_REFLECT(LVN_BEGINLABELEDIT, OnBeginLabelEdit)
	ON_NOTIFY_REFLECT(LVN_ENDLABELEDIT, OnEndLabelEdit)
	ON_WM_PAINT()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSubeditListView drawing

void CSubeditListView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CSubeditListView diagnostics

#ifdef _DEBUG
void CSubeditListView::AssertValid() const
{
	CListView::AssertValid();
}

void CSubeditListView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSubeditListView message handlers

void CSubeditListView::OnInitialUpdate() 
{
	CListView::OnInitialUpdate();

	CRect rect;
	GetClientRect(&rect);
	GetListCtrl().InsertColumn(0, "Col", LVCFMT_LEFT , rect.right / 2 , -1);
	GetListCtrl().InsertColumn(1, "Col", LVCFMT_LEFT , rect.right / 4 , -1);
	GetListCtrl().InsertColumn(2, "Col", LVCFMT_LEFT , rect.right / 4 , -1);


	GetListCtrl().InsertItem(0,"Item");
	GetListCtrl().InsertItem(2,"Item");
	GetListCtrl().InsertItem(3,"Item");
	GetListCtrl().SetItemText( 0, 1, "Subitem" );
	GetListCtrl().SetItemText( 0, 2, "Subitem" );
	GetListCtrl().SetItemText( 0, 3, "Subitem" );
	GetListCtrl().SetItemText( 1, 1, "Subitem" );
	GetListCtrl().SetItemText( 1, 2, "Subitem" );
	GetListCtrl().SetItemText( 1, 3, "Subitem" );
	GetListCtrl().SetItemText( 2, 1, "Subitem" );
	GetListCtrl().SetItemText( 2, 2, "Subitem" );
	GetListCtrl().SetItemText( 2, 3, "Subitem" );

	
	// TODO: Add your specialized code here and/or call the base class
	
}

BOOL CSubeditListView::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	cs.style |= LVS_REPORT|LVS_EDITLABELS;
	return CListView::PreCreateWindow(cs);
}

void CSubeditListView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	LVHITTESTINFO	lvhit;
	lvhit.pt = point;
	int item = GetListCtrl().SubItemHitTest(&lvhit);

	//if (over a subitem)
	if (item != -1 && lvhit.iSubItem && (lvhit.flags & LVHT_ONITEM ))
		{
		//mouse click outside the editbox in an allready editing cell cancels editing
		if (m_subitem == lvhit.iSubItem && item == m_item)
			{
			CListView::OnLButtonDown(nFlags, point);
			}
		else
			{
			CListView::OnLButtonDown(nFlags, point);

			m_subitem = lvhit.iSubItem;
			m_item = item;
			GetListCtrl().EditLabel(item);
			}

		}
	else
		CListView::OnLButtonDown(nFlags, point);
}



void CSubeditListView::OnBeginLabelEdit(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO* pDispInfo = (LV_DISPINFO*)pNMHDR;

	//if (subitem selected for editing)
	if (m_subitem)
		{
		ASSERT(m_item == pDispInfo->item.iItem);

		CRect	subrect;
		GetListCtrl().GetSubItemRect( pDispInfo->item.iItem, m_subitem, LVIR_BOUNDS , subrect );

		//get edit control and subclass
		HWND hWnd=(HWND)SendMessage(LVM_GETEDITCONTROL);
		ASSERT(hWnd!=NULL);
		VERIFY(m_editWnd.SubclassWindow(hWnd));

		//move edit control text 1 pixel to the right of org label, as Windows does it...
		m_editWnd.m_x=subrect.left + 6; 
		m_editWnd.SetWindowText(GetListCtrl().GetItemText(pDispInfo->item.iItem,m_subitem));

		//hide subitem text so it don't show if we delete some text in the editcontrol
		//OnPaint handles other issues also regarding this
		CRect	rect;
		GetListCtrl().GetSubItemRect(pDispInfo->item.iItem,m_subitem,LVIR_LABEL ,rect);
		CDC* hDc = GetDC();
		hDc->FillRect(rect,&CBrush(::GetSysColor(COLOR_WINDOW)));
		ReleaseDC(hDc);
		
		}

	//return: editing permitted
	*pResult = 0;

}

void CSubeditListView::OnEndLabelEdit(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_DISPINFO *plvDispInfo = (LV_DISPINFO *)pNMHDR;
	LV_ITEM	*plvItem = &plvDispInfo->item;

	//if (end of sub-editing) do cleanup
	if (m_subitem)
		{
		//plvItem->pszText is NULL if editing canceled
		if (plvItem->pszText != NULL )
			GetListCtrl().SetItemText(plvItem->iItem,m_subitem, plvItem->pszText);
		
		VERIFY(m_editWnd.UnsubclassWindow()!=NULL);
		
		m_subitem = 0;
		//allways revert to org label (Windows thinks we are editing the leftmost item)
		*pResult = 0;
		}
	else
		//return: update label on leftmost item
		*pResult = 1;

}

void CSubeditListView::OnPaint() 
{
	//if (subitem editing)
	if (m_subitem)
		{
		
		CRect	rect;
		CRect	editrect;

		GetListCtrl().GetSubItemRect(m_item,m_subitem,LVIR_LABEL ,rect);
		
		m_editWnd.GetWindowRect(editrect);
		ScreenToClient(editrect);

		//block text redraw of the subitems text (underneath the editcontrol)
		//if we didn't do this and deleted some text in the edit control, 
		//the subitems original label would show
		if (editrect.right < rect.right)
			{
			rect.left = editrect.right ;
			ValidateRect(rect);
			}
		
		//block filling redraw of leftmost item (caused by FillRect)
		GetListCtrl().GetItemRect(m_item,rect,LVIR_LABEL );
		ValidateRect(rect);
		}

	CListView::OnPaint();
}

void CSubeditListView::OnSize(UINT nType, int cx, int cy) 
{
	//stop editing if resizing
	if( GetFocus() != this ) SetFocus();

	CListView::OnSize(nType, cx, cy);
	
}
